package polyglot.ext.carcov;

import polyglot.types.*;
import polyglot.frontend.*;
import java.util.*;

/**
 * Extension info for the carcov extension, which composes the carray and
 * covarRet extensions.
 */
public class ExtensionInfo extends polyglot.ext.carray.ExtensionInfo {
    public static final Pass.ID COVAR_RET_CAST_REWRITE = polyglot.ext.covarRet.ExtensionInfo.COVAR_RET_CAST_REWRITE;

    public List passes(Job job) {
        List l = super.passes(job);
        beforePass(l, Pass.PRE_OUTPUT_ALL,
                  new VisitorPass(COVAR_RET_CAST_REWRITE,
                                  job, new polyglot.ext.covarRet.CovarRetRewriter(job, ts, nf)));
        return l;
    }

    /**
     * Create a type system, by composing type systems from each of the
     * extensions.
     */
    protected TypeSystem createTypeSystem() {
        return new CarcovTypeSystem();
    }
}
