package polyglot.ext.ibex.ast;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.types.*;
import polyglot.ext.ibex.types.*;
import polyglot.util.*;
import java.util.*;

/**
 * NodeFactory for ibex extension.
 */
public interface IbexNodeFactory extends NodeFactory {
    TerminalDecl TerminalDecl(Position pos, Flags flags, TypeNode type, String name);
    RuleDecl RuleDecl(Position pos, Flags flags, TypeNode type, String lhs, List choices, boolean isStart);
    RhsCaseNode RhsCaseNode(Position pos, List elements, Block action);
    RhsMergeNode RhsMergeNode(Position pos, List elements1, List elements2, Block action);
    Tagged Tagged(Position pos, String tag, SymbolNode sym);
    SuperSymbolNode SuperSymbolNode(Position pos, String name);
    SymbolNode SymbolNode(Position pos, String name);
}
