package polyglot.ext.j0.lang;

import java.io.*;

public class IO {

    private static BufferedReader reader;

    static {
	reader = new BufferedReader( new InputStreamReader( System.in ) );
    }

    public static void println(String s) {
	System.out.println(s);
    }

    public static void println(Object o) {
	System.out.println(o);
    }
    
    public static String readLine()  {
	try {
	    return( reader.readLine() );
	}
	catch( IOException ioe ) {
	    throw( new RuntimeException( ioe.getMessage() ) );
	}
    }

    public static char readChar() {
	try {
	    return( (char)reader.read() );
	}
	catch( IOException ioe ) {
	    throw( new RuntimeException( ioe.getMessage() ) );
	}
    }

    public static int readInt() {
	try {
	    return( Integer.parseInt( reader.readLine() ) );
	}
	catch( IOException ioe ) {
	    throw( new RuntimeException( ioe.getMessage() ) );
	}
	catch( NumberFormatException nfe ) {
	    throw( new RuntimeException( nfe.getMessage() ) );
	}
    }

    public static void print( boolean b ) {
	System.out.print( b );
    }

    public static void print( char c ) {
	System.out.print( c );
    }

    public static void print( char[] s ) {
	System.out.print( s );
    }

    public static void print( double d ) {
	System.out.print( d );
    }

    public static void print( float f ) {
	System.out.print( f );
    }

    public static void print( int i ) {
	System.out.print( i );
    }

    public static void print( long l ) {
	System.out.print( l );
    }

    public static void print( Object o ){
	System.out.print( o );
    }

    public static void print( String s ){
	System.out.print( s );
    }

    public static void println() {
	System.out.println();
    }

    public static void println( boolean x ) {
	System.out.println( x );
    }

    public static void println( char x ) {
	System.out.println( x );
    }

    public static void println( char[] x ) {
	System.out.println( x );
    }

    public static void println( double x ) {
	System.out.println( x );
    }

    public static void println( float x ) {
	System.out.println( x );
    }

    public static void println( int x ) {
	System.out.println( x );
    }

    public static void println( long x ) {
	System.out.println( x );
    }
}
