package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;

import java.util.*;

/**
 * A ParamNode is a parameter in an instantiation.
 * For example, in "SizedList[int, 5]", "int" and "5"
 * are both ParamNodes.
 */
public interface ParamNode extends Node { 
    /**
     * Return the parameter this node contains.
     * For a TypeParam, this is a Type; for an ExprParam, an Expr.
     * 
     * FIXME: We should be more precise than "Object" here.  
     * It would help to have a Param hierarchy in the types package.
     */
    Object parameter();
}
