/***********************************
 * This class is added to utilize the 
 * new polyglot framework. 
 * date: 6/17/2003
 *
 ***********************************/
 
 package polyglot.ext.polyj.ast;
 
import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.ext.polyj.extension.*;
import polyglot.util.*;
import java.util.*;

/**
 * ExtFactory for polyj extension
 * The ext should have a name PolyJxxxxExt, for now, it is still
 * PolyJxxxxDel.
 */
 
 public class PolyJExtFactory_c extends AbstractExtFactory_c {
	 public PolyJExtFactory_c() {
	 	super();
	 }
	
	private Ext defaultExt() {
		return new PolyJExt_c();
	}
	//new methods	 
	public Ext extMethodDeclImpl(){	return	defaultExt();};
	public Ext extConstructorDeclImpl(){	return	defaultExt();};
	public Ext extClassConstraint(){	return	defaultExt();};
	public Ext extMethodConstraint(){	return	defaultExt();};
	public Ext extConstructorConstraint(){	return	defaultExt();};
	public Ext extAmbNewArray(){	return	defaultExt();};	
	public Ext extInstTypeNode(){	return	defaultExt();};
	public Ext extAmbNameParam(){	return	defaultExt();};
	public Ext extExprParam(){	return	defaultExt();};
	public Ext extTypeParam(){	return	defaultExt();};
	public Ext extAmbInstOrAccess(){	return	defaultExt();};
	
	//Two new extensions for new nodes, overriding super class
	 public Ext extClassDeclImpl()
	 {
		 return new PolyJClassDeclExt();
         }
	 
	 public Ext extInitializerImpl()
	 {
		 return new PolyJInitializerExt();
	 }

	 public Ext extEvalImpl() {
	     return new PolyJEvalExt();
	 }
	 
	 //Extensions for old nodes.
	 //for all these, return the default extension PolyJDel_c
	 public Ext extNodeImpl()
	 {
		 return defaultExt();
	 }
 } 
	
