package polyglot.ext.polyj.parse;

import polyglot.ext.polyj.ast.*;

import polyglot.ast.*;
import polyglot.visit.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.parse.*;

import java.util.*;

/**
 * An AmbSub is a Sub whose syntax makes it ambiguous whether it is an expression
 * or a type.
 */
public class AmbSub extends AbstractSub {
    Parse p;
    
    public AmbSub(BaseParser parser, Position pos, Parse p) {
        super(parser, pos);
        this.p = p;
    }
    
    public Parse prepend(Parse base) throws Exception {
        return p.prepend(base);
    }
    
    public ParamNode toParam() throws Exception {
        return p.toParamNode();
    }
}
