package polyglot.ext.polyj.qq;

import polyglot.ast.*;
import polyglot.lex.Lexer;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;
import polyglot.frontend.*;
import polyglot.main.Report;

import polyglot.ext.jl.qq.QQParser;
import polyglot.ext.polyj.parse.UnwrapVisitor;
import polyglot.ext.polyj.qq.Grm;

import java.util.*;
import java.io.*;

public class QQ extends polyglot.ext.jl.qq.QQ {
    public QQ(ExtensionInfo ext) {
        super(ext);
    }

    public QQ(ExtensionInfo ext, Position pos) {
        super(ext, pos);
    }

    protected Lexer lexer(String text, Position pos, List subst) {
        return new polyglot.ext.polyj.qq.Lexer_c(text, pos, subst);
    }

    /** Create a quasiquoting parser. */
    protected QQParser parser(Lexer lexer, TypeSystem ts, NodeFactory nf, ErrorQueue eq) {
        return new polyglot.ext.polyj.qq.Grm(lexer, ts, nf, eq);
    }

    protected Node parse(String fmt, List subst, int kind) {
        Node n = super.parse(fmt, subst, kind);
        return n.visit(new UnwrapVisitor());
    }
}
